/*
 * GraphicTest.c
 *
 * Created: 18.06.2015 15:07:53
 *  Author: Dieter
 */ 

#include "Common.h"
#include "GraphicTest.h"

unsigned int Size = 0;
signed int p = 0;
char grows=1;
unsigned int Pos_x = 0;
int X_Rotation = 0, Y_Rotation = 0, Z_Rotation = 0;



void SSD1306_Graphic_fun_init(void)
{
	#if DISPLAY_TYPE == SSD1306_128_64
	_width  = WIDTH  = 128;
	_height = HEIGHT =  64;
	#endif
	#if DISPLAY_TYPE == SSD1306_128_32
	_width  = WIDTH  = 128;
	_height = HEIGHT =  32;
	#endif
	#if DISPLAY_TYPE == SSD1306_96_16
	_width  = WIDTH  =  96;
	_height = HEIGHT =  16;
	#endif


	rotation = 0;
	cursor_y = cursor_x = 0;
	textsize = 1;
	textcolor = textbgcolor = 0xFFFF;
	wrap = true;
}



void SSD1306_Graphic_fun(void)
{
	SSD1306_setCursor(0,0);
	
	for (uint8_t i=33; i<126; i++)
	{
		SSD1306_write(i);
		SSD1306_show();
	}

	_delay_ms(1000);

	SSD1306_clear();

	SSD1306_setCursor(0,0);
	
	for (uint8_t i=125; i>32; i--)
	{
		SSD1306_write(i);
	}
	
	SSD1306_show();

	_delay_ms(1000);

	SSD1306_clear();

	for (int16_t i=0; i<(SSD1306_height()/2); i+=2)
	{
		SSD1306_drawRectangle1(i,i,SSD1306_width()-i-2,SSD1306_height()-i-2);
		SSD1306_show();
	}

	_delay_ms(200);
	
	SSD1306_clear();
	
	for (int16_t i=0; i<SSD1306_height(); i+=4)
	{
		SSD1306_drawCircle( SSD1306_width()/2                     , SSD1306_height()/2, (SSD1306_height()/2 - 2 - i/2), SSD1306_WHITE);
		SSD1306_drawCircle((SSD1306_width()/2 - SSD1306_width()/4), SSD1306_height()/2,                           i/2 , SSD1306_WHITE);
		SSD1306_drawCircle((SSD1306_width()/2 + SSD1306_width()/4), SSD1306_height()/2,                           i/2 , SSD1306_WHITE);
		SSD1306_show();
	}
	
	_delay_ms(200);
	
	SSD1306_clear();
	
	for (int16_t i=0; i<SSD1306_height(); i+=4)
	{
		SSD1306_clear();
		SSD1306_drawCircle( SSD1306_width()/2                     , SSD1306_height()/2, (SSD1306_height()/2 - 2 - i/2), SSD1306_WHITE);
		SSD1306_drawCircle((SSD1306_width()/2 - SSD1306_width()/4), SSD1306_height()/2,                           i/2 , SSD1306_WHITE);
		SSD1306_drawCircle((SSD1306_width()/2 + SSD1306_width()/4), SSD1306_height()/2,                           i/2 , SSD1306_WHITE);
		SSD1306_show();
	}
	
	_delay_ms(200);
	
	SSD1306_clear();

	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// Rotating pyramid
	// The object is drawn in the not visible part of the Display-RAM
	// After drawing this Part is shown
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	for(p=0;p<300;p++)
	{
		X_Rotation+=1; // change the angles
		Y_Rotation+=1;
		Z_Rotation+=1;
		X_Rotation %= 62; Y_Rotation %= 62; Z_Rotation %= 62;  // because they should not become bigger than 62

		// draw the upper display-part
		SSD1306_clear();
		SSD1306_RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 50,HEIGHT/2,PYR,CNT_PYR,128); // draw the object
		SSD1306_RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 15,HEIGHT/2,Q,CNT_Q,128); // draw the object
		SSD1306_RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 90,HEIGHT/2,UFO,CNT_UFO, 64); // draw the object

		// draw the lower display-part
		X_Rotation+=1; // change the angles
		Z_Rotation+=1;
		//			 LCD_Clear(G_BASE1,G_END1); // clear the not visible part of diplay-Ram
		//			 RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 50,HEIGHT/2+HEIGHT,PYR,CNT_PYR,128); // draw the object
		//			 RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 15,HEIGHT/2+HEIGHT,Q,CNT_Q,128); // draw the object
		//			 RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 90,HEIGHT/2+HEIGHT,UFO,CNT_UFO, 64);  // draw the object
		//			 G_Zeile(64);                   //show the lower display-part

		SSD1306_show();
	}

	_delay_ms(200);
	
	SSD1306_clear();


	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// Flying viper (Starship like in C64-Elite)
	// The object is drawn in the not visible part of the Display-RAM
	// After drawing this Part is shown
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	SSD1306_clear();
	Pos_x = 0;
	while(Pos_x < (128*4))
	{
		X_Rotation++; // new rotating variables
		Y_Rotation = 32;
		Z_Rotation = 0;
		X_Rotation %= 62;  Y_Rotation %= 62;
		Pos_x += 1;	// fly from left to right

		// draw the upper display-part
		SSD1306_clear(); //clear the upper display-part
		SSD1306_RotatingObject(X_Rotation,Y_Rotation,Z_Rotation,Pos_x,HEIGHT/2,UFO,CNT_UFO, 64);

		X_Rotation+=1; // new rotating variables
		X_Rotation %= 62;
		Pos_x += 1;	// fly from left to right

		//			RotatingObject(X_Rotation,Y_Rotation,Z_Rotation,Pos_x,HEIGHT/2+HEIGHT,UFO,CNT_UFO, 64);
		
		SSD1306_show();

	}


	_delay_ms(200);

	SSD1306_clear();

	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// Viper flying around a Planet
	// The object is also drawn in the not visible part of the Display-RAM
	// After drawing this Part is shown
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	X_Rotation = 0;Y_Rotation = 0;Z_Rotation = 0;Size = 0; grows = 1;
	for(p=0;p<500;p++)
	{
		X_Rotation+=1; // change the angles
		Y_Rotation+=1;
		Z_Rotation+=1;
		X_Rotation %= 62;    Y_Rotation %= 62;    Z_Rotation %= 62;

		// getting closer or farer
		if(grows)   Size+=1;
		else	    Size-=1;
		if(Size == 0)   grows = 1;
		if(Size == 112) grows = 0;
		
		SSD1306_clear();
		SSD1306_Ball(X_Rotation,Y_Rotation,Z_Rotation, 64,HEIGHT/2,Size);
		SSD1306_RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 64 + (Size * SIN[X_Rotation])/256 ,HEIGHT/2,UFO,CNT_UFO, (Size * abs(SIN[X_Rotation/2]))/512);

		//			Ball(X_Rotation,Y_Rotation,Z_Rotation, 64,HEIGHT/2+HEIGHT,Size);
		//			RotatingObject(X_Rotation,Y_Rotation,Z_Rotation, 64 + (Size * SIN[X_Rotation])/256,HEIGHT/2+HEIGHT,UFO,CNT_UFO, (Size * abs(SIN[X_Rotation/2]))/512);
		
		SSD1306_show();
	}


	_delay_ms(200);

	SSD1306_clear();
}



//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Shows a vector-object
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// W1,W2,W3 -> the rotation of the object around x-, y-, and z-axsis
// x_pos and Y_pos -> the Position in the Display-Ram
// OBJ -> the Vector-Object to be shown
// cnt -> how many lines per Object
// size -> size: 128 is original size, 255 is double
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void SSD1306_RotatingObject(int W1,int W2,int W3, int x_Pos,int y_Pos,const int OBJ[][6],int cnt,int size)
{
	int M[4][4];
	int g,i;
	int z1,z2 ;
	int x1,x2 ;
	int y1,y2 ;
	int xr1,xr2 ;
	int yr1,yr2 ;

	// Rotation-Matrix
	// calculates the new position of the single vectors
	M[1][1] = ((long) COS[W2]*COS[W3]) /256;
	M[2][1] = ((long)-COS[W2]*SIN[W3]) /256;
	M[3][1] = SIN[W2];

	M[1][2] =  ((long)COS[W1]*SIN[W3])/256  + ((long)SIN[W1]*SIN[W2]*COS[W3])/((long)256 * 256);
	M[2][2] =  ((long)COS[W1]*COS[W3])/256  - ((long)SIN[W1]*SIN[W2]*SIN[W3])/((long)256 * 256);
	M[3][2] = ( (long) -SIN[W1]*COS[W2] ) / 256;

	M[1][3] =  ((long)SIN[W1]*SIN[W3])/256  - ((long)COS[W1]*SIN[W2]*COS[W3])/((long)256 * 256);
	M[2][3] =  ((long)SIN[W1]*COS[W3])/256  + ((long)COS[W1]*SIN[W2]*SIN[W3])/((long)256 * 256);

	M[3][3] =  ((long)COS[W1]*COS[W2])/256;

	if(size!=128)  // recalculate the size
	{
		for(g=1;g<4;g++) for(i=1;i<4;i++) M[g][i] =  (M[g][i] * size) / 128;
	};

	for(i=0;i<cnt;i++)  // draws the single lines
	{
		// get the line (from x1,y1,z1 to x2,y2,z2)
		x1 = OBJ[i][0];
		y1 = OBJ[i][1];
		z1 = OBJ[i][2];
		x2 = OBJ[i][3];
		y2 = OBJ[i][4];
		z2 = OBJ[i][5];

		// Convert the vector through the Rotation-Matrix
		xr1 = (M[1][1] * x1)/MUL + (M[2][1]*y1)/MUL + (M[3][1]*z1)/MUL;
		yr1 = (M[1][2] * x1)/MUL + (M[2][2]*y1)/MUL + (M[3][2]*z1)/MUL;
		xr2 = (M[1][1] * x2)/MUL + (M[2][1]*y2)/MUL + (M[3][1]*z2)/MUL;
		yr2 = (M[1][2] * x2)/MUL + (M[2][2]*y2)/MUL + (M[3][2]*z2)/MUL;

		// Draws the line
		SSD1306_LCD_Line( xr1 + x_Pos, yr1 + y_Pos, xr2 + x_Pos, yr2 + y_Pos);
	}
}


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// draws the Ball (planet?)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void SSD1306_Ball(int W1,int W2,int W3, int x_Pos,int y_Pos,int size)
{
	int M[4][4];

	register int g,i;
	int x,y,z;
	int xa,ya,za;
	int xb,yb;

	M[1][1] = ((long) COS[W2]*COS[W3]) /256;
	M[2][1] = ((long)-COS[W2]*SIN[W3]) /256;
	M[3][1] = SIN[W2];

	M[1][2] =  ((long)COS[W1]*SIN[W3])/256 + ((long)SIN[W1]*SIN[W2]*COS[W3])/((long)256 * 256);
	M[2][2] =  ((long)COS[W1]*COS[W3])/256 - ((long)SIN[W1]*SIN[W2]*SIN[W3])/((long)256 * 256);
	M[3][2] = ((long)-SIN[W1]*COS[W2])/256;

	M[1][3] =  ((long)SIN[W1]*SIN[W3])/256 - ((long)COS[W1]*SIN[W2]*COS[W3])/((long)256 * 256);
	M[2][3] =  ((long)SIN[W1]*COS[W3])/256 + ((long)COS[W1]*SIN[W2]*SIN[W3])/((long)256 * 256);
	M[3][3] =  ((long)COS[W1]*COS[W2])/256;

	if(size!=128)
	{
		for(g=1;g<4;g++) for(i=1;i<4;i++) M[g][i] =  (M[g][i] * size) / 128;
	};


	for (g=0;g<31;g+=8)
	{
		for (i=0;i<62;i++)
		{
			z = SIN[i] / 8;
			x = ((COS[i]/2) * (COS[g]/2)) / (2 * 256);
			y = ((COS[i]/2) * (SIN[g]/2)) / (2 * 256);

			ya = (M[1][2] * x)/MUL + (M[2][2]*y)/MUL + (M[3][2]*z)/MUL;
			if (ya >=0)	// just the positive y-values; otherwise the Ball is transparent
			{
				xa = (M[1][1] * x)/MUL + (M[2][1]*y)/MUL + (M[3][1]*z)/MUL;
				za = (M[1][3] * x)/MUL + (M[2][3]*y)/MUL + (M[3][3]*z)/MUL;
				xb = x_Pos + xa ;
				yb = y_Pos + za ;
				SSD1306_lcd_setpixel(xb,yb);
			};
		}
	}
	for (i=15;i < 45;i+=4)
	{
		for (g=0;g < 62; g++)
		{
			z = SIN[i] / 8;
			x = ((COS[i]/2) * (COS[g]/2)) / (2 * 256);
			y = ((COS[i]/2) * (SIN[g]/2)) / (2 * 256);


			ya = (M[1][2] * x)/MUL + (M[2][2]*y)/MUL + (M[3][2]*z)/MUL;
			if (ya >=0) // just the positive y-values; otherwise the Ball is transparent
			{
				xa = (M[1][1] * x)/MUL + (M[2][1]*y)/MUL + (M[3][1]*z)/MUL;
				za = (M[1][3] * x)/MUL + (M[2][3]*y)/MUL + (M[3][3]*z)/MUL;
				xb = x_Pos + xa ;
				yb = y_Pos + za ;
				SSD1306_lcd_setpixel(xb,yb);
			};
		}
	}
}
