/*
 * GraphicTest.h
 *
 * Created: 18.06.2015 15:08:07
 *  Author: Dieter
 */ 


#ifndef GRAPHICTEST_H_
#define GRAPHICTEST_H_

#define     MUL 256      // because of fixcomma-calculations

//Drawing functions from original programm replaced
//by functions in T6963.c and Draw.c. Tell the compiler
//new function names, so we don't have to change
//original code below !
#define SSD1306_lcd_setpixel(a,b) SSD1306_drawPixel2((a),(b),1)
#define SSD1306_Cls() clear()
#define SSD1306_LCD_Line(x,y,x1,y1) SSD1306_drawLine((x),(y),(x1),(y1),1)


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// To calculate sin and cosin (Tables are much faster than the library)
// 62 points because of 2 Pi = 6,2..
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
const int SIN[64]={
	0,25,50,75,99,122,144,164,183,200,215,228,238,246,252,255,255,253,249,242,232,
	220,206,190,172,153,131,109,85,61,36,10,-14,-40,-65,-89,-113,-135,-156,-176,
	-193,-209,-223,-234,-243,-250,-254,-255,-255,-251,-245,-237,-226,-213,-197,
-180,-161,-140,-118,-95,-71,-46,-21};

const int COS[64]={ 255,254,250,244,235,224,211,195,178,159,138,116,92,68,43,18,-7,-32,
	-58,-82,-106,-129,-150,-170,-188,-205,-219,-231,-241,-248,-253,-255,-255,-252,
	-247,-239,-229,-217,-202,-185,-167,-147,-125,-102,-78,-53,-28,
-3,22,47,72,96,119,141,162,181,198,213,226,237,245,251,255};
//                     ^^^ was 16 ! Inserted right value HK

// Spaceship  (like Viper in C64-Elite)
#define  PNT_A    00,+00,+15  // defines the 3D vektors (edges of the spaceship)
#define  PNT_B   -70,+00,-15  // Nose
#define  PNT_C   +10,+40,-15
#define  PNT_F   +10,-40,-15
#define  PNT_D   +35,+20,-15
#define  PNT_E   +35,-20,-15
#define  PNT_G   -40,+00,-15
#define  PNT_H   +10,+20,-15
#define  PNT_I   +10,-20,-15
#define  CNT_UFO  13  // consists of 13 lines

const int UFO[CNT_UFO][6]=
{
	{ PNT_B,PNT_C},	 // Lines between these Points
	{ PNT_B,PNT_A},
	{ PNT_B,PNT_F},
	{ PNT_C,PNT_A},
	{ PNT_F,PNT_A},
	{ PNT_D,PNT_A},
	{ PNT_E,PNT_A},
	{ PNT_E,PNT_F},
	{ PNT_E,PNT_D},
	{ PNT_C,PNT_D},
	{ PNT_G,PNT_H},
	{ PNT_G,PNT_I},
	{ PNT_H,PNT_I}
};

// Pyramide
#define PYR_A    00,+00,-10
#define PYR_B   -15,-8,+10
#define PYR_C   +15,-8,+10
#define PYR_D   +00,17,+10
#define CNT_PYR  6

const int PYR[CNT_PYR][6]=
//              ^^^ Was CNT_UFO. Too large ;)
{
	{ PYR_A,PYR_B},
	{ PYR_A,PYR_D},
	{ PYR_A,PYR_C},
	{ PYR_B,PYR_C},
	{ PYR_B,PYR_D},
	{ PYR_D,PYR_C}
};

// Quader added by Holger Klabunde
#define Q_A    -10,-10,10
#define Q_B   10,-10,10
#define Q_C   10,-10,-10
#define Q_D   -10,-10,-10
#define Q_E   -10,10,10
#define Q_F   10,10,10
#define Q_G   10,10,-10
#define Q_H   -10,10,-10
#define CNT_Q 12

const int Q[CNT_Q][6]=
{
	{ Q_A,Q_B},
	{ Q_A,Q_D},
	{ Q_A,Q_E},
	{ Q_B,Q_C},
	{ Q_B,Q_F},
	{ Q_C,Q_G},
	{ Q_C,Q_D},
	{ Q_D,Q_H},
	{ Q_E,Q_F},
	{ Q_E,Q_H},
	{ Q_H,Q_G},
	{ Q_G,Q_F}
};


void SSD1306_RotatingObject(int W1,int W2,int W3, int x_Pos,int y_Pos,const int OBJ[][6],int cnt,int size);
void SSD1306_Ball(int W1,int W2,int W3, int x_Pos,int y_Pos,int size);
void SSD1306_Graphic_fun(void);
void SSD1306_Graphic_fun_init(void);



#endif /* GRAPHICTEST_H_ */