/*
This is free and unencumbered software released into the public domain.

Anyone is free to copy, modify, publish, use, compile, sell, or
distribute this software, either in source code form or as a compiled
binary, for any purpose, commercial or non-commercial, and by any
means.

In jurisdictions that recognize copyright laws, the author or authors
of this software dedicate any and all copyright interest in the
software to the public domain. We make this dedication for the benefit
of the public at large and to the detriment of our heirs and
successors. We intend this dedication to be an overt act of
relinquishment in perpetuity of all present and future rights to this
software under copyright law.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

For more information, please refer to <http://unlicense.org/>
*/

#include "Common.h"



void i2c_init(void) 
{

	// Setup TWI bus
	TWIE.MASTER.BAUD	= TWI_BAUD_RATE;																				// Set TWI baud rate
	TWIE.MASTER.CTRLA	= TWI_MASTER_INTLVL_LO_gc | TWI_MASTER_RIEN_bm | TWI_MASTER_WIEN_bm | TWI_MASTER_ENABLE_bm;		// Enable TWIE module
	TWIE.MASTER.CTRLB	= TWI_MASTER_TIMEOUT_200US_gc;																	// Set TWIE inactivity timeout to 200s
	TWIE.MASTER.STATUS	= TWI_MASTER_BUSSTATE_IDLE_gc;																	// Force TWIE module to be idle

}

uint8_t i2c_start(uint8_t address) 
{
	
	 TWIE.MASTER.ADDR	= address;																						// Send address
	 while(!(TWIE.MASTER.STATUS & TWI_MASTER_WIF_bm));																	// Wait for TWI to be idle again
	
     return 0;
}

uint8_t i2c_write(uint8_t data) 
{

	TWIE.MASTER.DATA = data;																							// Send byte
	while(!(TWIE.MASTER.STATUS & TWI_MASTER_WIF_bm));																	// Wait for TWI to be idle again

	return 0;
}

void i2c_stop(void) 
{
	
	
	
/*
    TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
    while(TWCR & (1<<TWSTO));
*/
}