/*
 * SSD1289.h
 *
 * Created: 23.06.2015 08:52:41
 *  Author: Rolf Degen 
 */ 

// SPI line pins
#define SPIPort PORTD
#define SPIMO   7
#define SPIMI   6
#define SPISC   5
#define SPISS   4


// control line pins
#define  LCD_RS  PIN0   //  Command (DC for Parallel Interface)
#define  LCD_WR  PIN1   //  RW (read an write cycle indicator)
#define  LCD_CS  PIN2   //  Chip Select
#define  LCD_RES PIN3   //  RESET
#define  LCD_74  PIN3   //  74HC575 Ausgabe

// macros for control lines
#define CLR_RS PORTA.OUT &= ~(1<<LCD_RS);
#define SET_RS PORTA.OUT |=  (1<<LCD_RS);

#define CLR_CS PORTA.OUT &= ~(1<<LCD_CS);
#define SET_CS PORTA.OUT |=  (1<<LCD_CS);

#define CLR_RESET PORTA.OUT &= ~(1<<LCD_RES);
#define SET_RESET PORTA.OUT |=  (1<<LCD_RES);

#define CLR_WR PORTA.OUT &= ~(1 << LCD_WR);
#define SET_WR PORTA.OUT |=  (1 << LCD_WR);

#define CLR_74HC595 PORTB.OUT &= ~(1 << LCD_74);
#define SET_74HC595 PORTB.OUT |=  (1 << LCD_74);



//#define CLR_RD PORTC.OUT &= ~(1 << LCD_RD);
//#define SET_RD PORTC.OUT |=  (1 << LCD_RD);

//#define  LCD_DataPortH 					PORTE.OUT
//#define  LCD_DataPortL 					PORTD.OUT

#define BLACK                           0x00, 0x00
#define RED                             0xf8, 0x00
#define GREEN                           0x07, 0xe0
#define BLUE                            0x00, 0x1f
#define WHITE                           0xff, 0xff
#define PURPLE                          0xf1, 0x1f
#define YELLOW                          0xff, 0xe0
#define CYAN                            0x07, 0xff


void spiopen(void);
void spiclose(void);
uint8_t spi(uint8_t val);

void SSD1289_init(void);
void SSD1289_Address_set(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2);
void SSD1289_set_Cursor(unsigned int x,unsigned int y,unsigned int x2,unsigned int y2);
void SSD1289_main_W_com_data(int com1,int dat1);
void SSD1289_LCD_Write_COM(char VH,char VL);
void SSD1289_LCD_Write_DATA(char VH,char VL) ;
void SSD1289_LCD_Writ_Bus(char VH,char VL);
void SSD1289_Paint(char VH,char VL);
void SSD1289_vline(int x, int y, int l, char VH, char VL);
void SSD1289_hline(int x, int y, int l, char VH, char VL);
void SSD1289_pixel(int x, int y, char VH, char VL);
void SSD1289_rectangle(int x, int y, int height, int width, char VH, char VL);
void SSD1289_fillrectangle(int x1, int y1, int x2, int y2, char VH, char VL);
int  SSD1289_strlen(const char *str); 
void SSD1289_drawstring(char str[], int x, int y, int multiplier, char VH, char VL);
void SSD1289_drawchar(int ascii, int x, int y, int multiplier, char VH, char VL);
void SSD1289_drawstring(char str[], int x, int y, int multiplier, char VH, char VL);
void SSD1289_drawrighttriangle(int x, int y, int height);
void SSD1289_drawlefttriangle(int x, int y, int height);